/*============================================================================
|   Copyright (C) 2001-2003  Jonathan Harm
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   delete_query.c REV 3 for SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 


#include "querygen.h"


void delete_query( void )
{

  extern char out[MAX];
  extern char ctqfile[MAX];	                       // this is the CREATE TABLE query file
  char delete_query[BIGBUF];                  //this is what is written to the file
  char *unique_query;                                //contains the WHERE clause(s)
  char table_or_row;	                               //ask user if they want to delete the table or row
  char *tablename;
  int loop_done, user_done;                     //used to control loops
  extern int appendfile;
  extern int printstdout;
  extern int useoutputfile;

   FILE *fpctq, *fpout;



  //First open "ctq" in read only mode and open "out" for writing

  if( (fpctq = fopen(ctqfile, "r")) == NULL) {
    fprintf(stderr, "\nCouldn't open file %s\n", ctqfile);
    exit(1);
    }


if(useoutputfile == 1)
{

  if(appendfile == 1)
  {

      if( (fpout = fopen(out, "a")) == NULL)
      {
         fprintf(stderr, "\nCouldn't create file %s\n", out);
         exit(2);
        }

  }


  else
  {

        if( (fpout = fopen(out, "w")) == NULL)
        {
            fprintf(stderr, "\nCouldn't create file %s\n", out);
            exit(2);
         }

    fprintf(fpout, "/* This file made by SQL Query Generator %.1f*/\n", PROGRAM_VERSION);
    fprintf(fpout, "/* go to http://change.to/opensource for the latest updates */\n\n\n");
  }

} //end of "if(useoutputfile ==1)"




  while( loop_done != 1)
  {


     rewind(fpctq); //rewind so gettable() wont return 0 when the loop restarts
     if( (tablename = gettable(fpctq)) == 0)
     exit(1);

     if(tablename[0] == '\0') //if the user pressed enter the first time they were presented with the table name(s)
       exit(0);



       //ask user if they want to delete the whole table or only certain rows
       printf("\nDo you want to delete the whole [T]able or only certain [R]ow(s)? ");
       table_or_row = toupper(getc(stdin));
       getc(stdin); //eat newline


       if( table_or_row == 'T' )
       {

           //we already have the table name, now make the query
           sprintf(delete_query, "DELETE FROM %s;\n\n", tablename);

           if(printstdout == 1) {
            printf("\nHere is your query:\n\n\n");
            printf("%s", delete_query);
            }
           
          //write query to output file
           if(useoutputfile == 1)
            fprintf(fpout, "%s", delete_query);

       }




       //First get tablename, then ask user what column has unique
       //info about the row(s) that they want to delete.  Then ask for
       //the unique info.  Don't forget to check for the datatype before
       //writing the unique info to the query.

       if( table_or_row == 'R' )
       {

           //start out by making the first part of the query
           sprintf(delete_query, "DELETE FROM %s", tablename);


             unique_query = where_clause(fpctq, tablename);
           
 
      //for info on the line below, see first comment in the while(loop_done != 1) loop
      if(unique_query[0] == '\0') {fprintf(stderr, "\nError: Invalid column name.\n"); exit(1); }


           if(printstdout == 1)  {
            printf("\nHere is your query:\n\n\n");
            printf( "%s\n%s;\n\n", delete_query, unique_query);
            }

           if(useoutputfile == 1)
            fprintf(fpout, "%s\n%s;\n\n", delete_query, unique_query);

        } //end of if(table_or_row == 'R')



        printf("\nAre you done making DELETE queries?(N/y)");

         user_done = toupper(getc(stdin));

         switch (user_done) {

                 case 'Y' :

                     printf("\nThank you for using SQL Query Generator %.1f.\n", PROGRAM_VERSION);

                      //close files before exiting
                      if(useoutputfile == 1) fclose(fpout);
                      fclose(fpctq);
                      loop_done = 1;

                      break;


                 case 'N' :
                       loop_done = 0;                     
                       getc(stdin); //eat newline

                       break;


                 default :
                        loop_done = 0;

                         break;

                } //end of switch


  } //end of while(loop_done != 1)

exit(0);

}
